Bug 438452 - Review Request: java-gnome: Java GNOME bindings
Review Request: java-gnome: Java GNOME bindings
Status: CLOSED DUPLICATE of bug 551587
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity low
: ---
: ---
Assigned To: Mary Ellen Foster
Fedora Extras Quality Assurance
:
: 242335 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-03-20 20:59 EDT by Colin Walters
Modified: 2012-04-23 19:21 EDT (History)
14 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-05-11 16:34:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Colin Walters 2008-03-20 20:59:30 EDT
SRPM: http://cdn.verbum.org/java-gnome-4.0.6.bzr20080320-1.fc9.src.rpm
SPEC: http://cdn.verbum.org/java-gnome.spec

%description
These are the Java bindings for GTK and GNOME! Featuring a robust 
engineering design, completely generated internals, a lovingly 
crafted layer presenting the public API, and steadily increasing 
coverage of the underlying libraries.

You can use java-gnome to develop sophisticated user interfaces 
for Linux applications so that they richly integrate with the 
GNOME Desktop while leveraging the power of the Java language 
and your expertise with it.
Comment 1 Colin Walters 2008-03-20 21:36:58 EDT
I just updated the .spec file to address a few issues:

* Fixed license (it's GPL+exception, not LGPLv2+)
* Added link to second patch in GNOME bugzilla
Comment 2 Colin Walters 2008-04-04 20:27:10 EDT
Updates to this one coming.
Comment 4 Jason Tibbitts 2008-04-05 00:47:19 EDT
This failed to build in mock for me:

Check for required jar files:
 - JUnit test framework            not found!
In order to build java-gnome, you need
        junit.jar       (looked in /usr/share/java)
which is part of the JUnit test framework Java library.
On a Fedora system, you should be able to get this requirement by doing:
     # yum install junit
Failed to complete configuration.

I added a build dependency on junit and the build fails later:

+ make install DESTDIR=/var/tmp/java-gnome-4.0.6-0.1.20080404bzr.fc9-2XFrfw
/usr/bin/env: python: Permission denied

which I admit I don't completely understand.  However, python is not in the
build root, so I added it and the build fails later:

+ make install DESTDIR=/var/tmp/java-gnome-4.0.6-0.1.20080404bzr.fc9-zqtPuh
sh: pkg-config: command not found
sh: pkg-config: command not found
MKDIR   tmp/stamp/
[...]
Note: Some input files use unchecked or unsafe operations.
Note: Recompile with -Xlint:unchecked for details.
JAVA    BindingsGenerator
JAVAC   src/bindings/*.java, generated/bindings/*.java
src/bindings/org/freedesktop/cairo/Surface.java:28:
destroy(org.freedesktop.cairo.ImageSurface) in
org.freedesktop.cairo.CairoSurface cannot be applied to
(org.freedesktop.cairo.Surface)
        CairoSurface.destroy(this);
                    ^
[several other analogous complaints]
9 errors
make: *** [build-java] Error 1

I've no clue what to add to get past this.
Comment 5 Colin Walters 2008-04-05 11:49:18 EDT
Thanks, I fixed the build deps and re-uploaded new versions.

http://cdn.verbum.org/java-gnome.spec
http://cdn.verbum.org/java-gnome-4.0.6-0.1.20080404bzr.fc9.src.rpm

Basically we were missing glade2-devel (and its deps).
Comment 6 Andrew Overholt 2008-05-12 16:16:50 EDT
Doesn't frysk need the 2.x (API-incompatible AFAIK) bindings?
Comment 7 Matěj Cepl 2008-05-14 02:54:30 EDT
(In reply to comment #6)
> Doesn't frysk need the 2.x (API-incompatible AFAIK) bindings?

We could carry both, couldn't we?
Comment 8 Andrew Overholt 2008-05-14 10:05:45 EDT
(In reply to comment #7)
> (In reply to comment #6)
> > Doesn't frysk need the 2.x (API-incompatible AFAIK) bindings?
> 
> We could carry both, couldn't we?

Of course, but not with the currently-proposed 4.x packages.  We'd need
java-gnome2 or java-gnome4.
Comment 9 Colin Walters 2008-05-14 17:44:18 EDT
New version:

http://cdn.verbum.org/java-gnome.spec
http://cdn.verbum.org/java-gnome-4.0.7-1.fc9.src.rpm

Andrew, why do you think they would conflict?  The old packages were all called
"lib*-java" and notably libgtk-java installs as gtk2.8.jar; this one is called
"java-gnome" which matches upstream, and the installed jar is just called gtk.jar.
Comment 10 Matěj Cepl 2008-05-15 12:05:11 EDT
Maintainer of the original java-gnome should be probably present on this bug, right?
Comment 11 Andrew Overholt 2008-05-20 08:54:47 EDT
(In reply to comment #9)

> Andrew, why do you think they would conflict?  The old packages were all called
> "lib*-java" and notably libgtk-java installs as gtk2.8.jar; this one is called
> "java-gnome" which matches upstream, and the installed jar is just called gtk.jar.

Because I didn't think about it before I wrote that :)  Nevermind my stupidity ...

Comment 12 Martin Garton 2008-11-30 06:15:42 EST
What is still remaining to do before this can move forward?
Comment 13 Jason Tibbitts 2008-12-01 00:14:54 EST
Pretty simple, really; a reviewer needs to do a proper review.
Comment 14 Mary Ellen Foster 2009-02-06 08:49:26 EST
Here's my stab at a review ...

Summary: there's a minor rpmlint issue with the SRPM and a need for more
details about where the source comes from, and a more confusing issue
regarding where the files should be installed.

I'm also not sure whether to care that the gcc invocations don't use
$RPM_OPT_FLAGS and that make doesn't use %{?_smp_mflags}.

Main packaging guidelines:

[-] MUST: rpmlint must be run on every package. The output should be posted in
the review.

    % rpmlint -i ../SRPMS/java-gnome-4.0.7-1.fc10.src.rpm ../RPMS/i386/java-gnome-*
    java-gnome.src: W: patch-not-applied Patch1: java-gnome-4.0.6-jnipath.patch
    A patch is included in your package but was not applied. Refer to the patches
    documentation to see what's wrong.

    3 packages and 0 specfiles checked; 0 errors, 1 warnings.

[+] MUST: The package must be named according to the Package Naming Guidelines .

[+] MUST: The spec file name must match the base package %{name}, in the format
%{name}.spec unless your package has an exemption.

[+] MUST: The package must meet the Packaging Guidelines .

[+] MUST: The package must be licensed with a Fedora approved license and meet
the Licensing Guidelines .

[+] MUST: The License field in the package spec file must match the actual
license.

[+] MUST: If (and only if) the source package includes the text of the
license(s) in its own file, then that file, containing the text of the
license(s) for the package must be included in %doc.

[+] MUST: The spec file must be written in American English.

[+] MUST: The spec file for the package MUST be legible.

[-] MUST: The sources used to build the package must match the upstream source,
as provided in the spec URL. Reviewers should use md5sum for this task. If
no upstream URL can be specified for this package, please see the Source
URL Guidelines for how to deal with this.

    Give a script or a command sequence for getting the given BZR snapshot
    from the repository

[+] MUST: The package MUST successfully compile and build into binary rpms on
at least one primary architecture.

[+] MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed
in bugzilla, describing the reason that the package does not
compile/build/work on that architecture. The bug number MUST be placed in a
comment, next to the corresponding ExcludeArch line.

[+] MUST: All build dependencies must be listed in BuildRequires, except for
any that are listed in the exceptions section of the Packaging Guidelines ;
inclusion of those as BuildRequires is optional. Apply common sense.

[+] MUST: The spec file MUST handle locales properly. This is done by using the
%find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

[+] MUST: Every binary RPM package (or subpackage) which stores shared library
files (not just symlinks) in any of the dynamic linker's default paths,
must call ldconfig in %post and %postun.

[+] MUST: If the package is designed to be relocatable, the packager must state
this fact in the request for review, along with the rationalization for
relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker.

[+] MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which
does create that directory.

[+] MUST: A package must not contain any duplicate files in the %files listing.

[+] MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every %files section must include
a %defattr(...) line.

[+] MUST: Each package must have a %clean section, which contains rm -rf
%{buildroot} (or $RPM_BUILD_ROOT).

[+] MUST: Each package must consistently use macros.

[+] MUST: The package must contain code, or permissable content.

[+] MUST: Large documentation files must go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity).

[+] MUST: If a package includes something as %doc, it must not affect the
runtime of the application. To summarize: If it is in %doc, the program
must run properly if it is not present.

[+] MUST: Header files must be in a -devel package.

[+] MUST: Static libraries must be in a -static package.

[+] MUST: Packages containing pkgconfig(.pc) files must 'Requires:
pkgconfig' (for directory ownership and usability).

[+] MUST: If a package contains library files with a suffix (e.g.
libfoo.so.1.1), then library files that end in .so (without suffix) must go
in a -devel package.

[+] MUST: In the vast majority of cases, devel packages must require the
base package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release}

[+] MUST: Packages must NOT contain any .la libtool archives, these must be
removed in the spec if they are built.

[+] MUST: Packages containing GUI applications must include a %{name}.desktop
file, and that file must be properly installed with desktop-file-install in
the %install section. If you feel that your packaged GUI application does
not need a .desktop file, you must put a comment in the spec file with your
explanation.

[+] MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership
with any of the files or directories owned by the filesystem or man
package. If you feel that you have a good reason to own a file or directory
that another package owns, then please present that at package review time.

[+] MUST: At the beginning of %install, each package MUST run rm -rf
%{buildroot} (or $RPM_BUILD_ROOT).

[+] MUST: All filenames in rpm packages must be valid UTF-8.


[+] SHOULD: If the source package does not include license text(s) as a
separate file from upstream, the packager SHOULD query upstream to include
it.

[+] SHOULD: The description and summary sections in the package spec file
should contain translations for supported Non-English languages, if
available.

[+] SHOULD: The reviewer should test that the package builds in mock.

[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.

    http://koji.fedoraproject.org/koji/taskinfo?taskID=1109207

[+] SHOULD: The reviewer should test that the package functions as
described. A package should not segfault instead of running, for example.

[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is
vague, and left up to the reviewers judgement to determine sanity.

[+] SHOULD: Usually, subpackages other than devel should require the base
package using a fully versioned dependency.

[+] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and
this is usually for development purposes, so should be placed in a -devel
pkg. A reasonable exception is that the main pkg itself is a devel tool not
installed in a user runtime, e.g. gcc or gdb.

[+] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the
file instead of the file itself.


Java-specific guidelines:

[-] If the project name and the commonly used JAR filename differ, a symbolic
link with the usual name must also be provided.

    If I understand this guideline correctly, the jar file generated by
    this package should be called java-gnome.jar, with gtk.jar as a
    symbolic link.

[*] All JAR files MUST go into %{_javadir}.

    But see below ...

[+] Java-specific BuildRequires/Requires look good

[?] Since this package builds with OpenJDK, I'm not sure about the status
of the GCJ guidelines. Probably not applicable ...

[-] There are conflicting guidelines about JNI -- on the one hand, it says
that 
    "JAR files that require JNI shared objects MUST be installed in
     %{_libdir}/%{name}. The JNI shared objects themselves must also be
     installed in %{_libdir}/%{name}."
On the other hand, there's language about using %{_jnidir}. So I think that
the guidelines allow either of the following layouts:
    1. Everything into %{_libdir}/java-gnome
    2. Jars in %{_libdir}/java, shared objects in %{_libdir}/jni
The current package has jars in %{_javadir} and shared objects in
%{_libdir}/java, which doesn't meet either of these possibilities.
Comment 15 Stepan Kasal 2009-04-20 13:30:13 EDT
(In reply to comment #14)
> [-] If the project name and the commonly used JAR filename differ, a symbolic
> link with the usual name must also be provided.
> 
>     If I understand this guideline correctly, the jar file generated by
>     this package should be called java-gnome.jar, with gtk.jar as a
>     symbolic link.

I think this qualifies as an exception: java-gnome was always a name for a collection of several smaller projects--the bindings for various layers of gnome libraries.

Calling any of the jars delivered by this rpm as java-gnome.jar would make little sense and confuse people.
Comment 16 Stepan Kasal 2009-04-20 13:32:32 EDT
*** Bug 242335 has been marked as a duplicate of this bug. ***
Comment 17 Alexander Boström 2009-07-04 06:38:39 EDT
I've posted an updated package here, informally:

http://www.root.snowtree.se/abo/fedora/reviews/java-gnome/

New release, added javadocs etc.

I did not attempt to address everything in comment #14 (and for example I don't know if a JAR symlink would be a good thing), but hopefully this saves Colin Walters some time. Feel free to check/fix/repost it for review.

Also, I put the examples in the -javadoc package, which isn't really correct.
Comment 18 Alexander Boström 2009-12-31 08:23:04 EST
I submitted an updated package in a new review request: bug 551587
I guess this one should be marked a dup. of the new one unless Colin Walters feels like picking it up again (in which case I'll close my request).
Comment 19 Mat Booth 2010-05-11 16:34:39 EDT
A newer review of this package has been approved.

*** This bug has been marked as a duplicate of bug 551587 ***

Note You need to log in before you can comment on or make changes to this bug.